unit LawStr;

interface

uses Controls;

function RS(const S, Srch, Replace: string): string;
Function IntToStrZero(mit,hossz:Longint):String;
Function StrToIntZero(Const mit:String):Longint;
Function LeftFillStr(mit:String; Mivel:Char; hossz:Longint):String;
Function RightFillStr(mit:String; Mivel:Char; hossz:Longint):String;
function AddSlash(const Directory: string): string;
function DelLeadingSlash(const Directory:string):string;
function AddPer(const szoveg:string):string;
function AddHttp(const szoveg:string):string;
function UnEscapeString(const szoveg,escape:string):string;
function MyExtractWord(const n:Integer;const mibol:String;const elvalaszto:Char):String;
function IsStrEmpty(const s:String):Boolean;
function OEM2Ansi(const s:String):String;
function Ansi2OEM(const s:String):String;
function CharCount(const miben:string; const mit:Char):Integer;
function Str2Int(const s:string):Integer;
function Winesit(const mit:string):string;
function Dososit(const mit:string):string;
function Ekezettelenit(const szoveg:string):string;
function CutLastChar(const mibol:string):string;
Function SzamotBetuvel(Szamm: Longint;Const Valuta: String): String;overload;
Function SzamotBetuvel(Szamm: Double;Const Valuta: String): String;overload;
Function SzamotBetuvel2(Szamm: Longint): String;  // Nincs hozza forint
Function SzamotBetuvel3(Szamm: Double;Const Valuta: String): String;
Function SzamotBetuvel_4(Const Szam: Double): String;  // Megcsinalja a tortet is!
Function MyMod(Const X,Y: Double): Longint;
function AddSeparated(const mihez,s,sep:string):string;
function LeftCopy(const mibol:string;const mennyit:integer):string;
function DateToLongStr(const mibol:TDate):string;
function TimeToFileName(const mibol:TDateTime):string;
function DateToFileName(const mibol:TDateTime):string;
function DateToExcel(const mibol:TDateTime):string;
procedure CimSzetszed(const cim:string;var irszam,varos,utca:string);
function FloatToStrEzres(const mibol:extended):string;
function CreateAddress(const irszam,varos,utca:string):string;

implementation

Uses SysUtils, Math;

function RS(const S, Srch, Replace: string): string;
var
  I: Integer;
  Source: string;
begin
  Source := S;
  Result := '';
  repeat
    I := Pos(Srch, Source);
    if I > 0 then begin
      Result := Result + Copy(Source, 1, I - 1) + Replace;
      Source := Copy(Source, I + Length(Srch), MaxInt);
    end
    else Result := Result + Source;
  until I <= 0;
end;

Function IntToStrZero(mit,hossz:Longint):String;
Var work:String;
    cikl:Integer;
Begin
  Result:='';
  Str(mit,work);
  If Length(work)<hossz
  Then Begin
         For cikl:=1 To hossz-Length(work) Do
           Result:=Result+'0';
         Result:=Result+work;
       End
  Else Result:=work;
End;

Function StrToIntZero(Const mit:String):Longint;
Begin
  Try
    Result:=StrToInt(mit);
  Except
    Result:=0;
  End;
End;

Function LeftFillStr(mit:String; Mivel:Char; hossz:Longint):String;
Var cikl:Integer;
Begin
  Result:='';
  If Length(mit)<hossz
  Then Begin
         For cikl:=1 To hossz-Length(mit) Do
           Result:=Result+mivel;
         Result:=Result+mit;
       End
  Else Result:=mit;
End;

Function RightFillStr(mit:String; Mivel:Char; hossz:Longint):String;
Var cikl:Integer;
Begin
  Result:='';
  If Length(mit)<hossz
  Then Begin
         Result:=mit;
         For cikl:=1 To hossz-Length(mit) Do
           Result:=Result+mivel;
       End
  Else Result:=mit;
End;

function AddSlash(const Directory: string): string;
begin
  if Length(Trim(Directory)) = 0 then
    Result := ''
  else
    if Directory[Length(Directory)] <> '\' then
      Result := Directory + '\'
    else
      Result := Directory;
end;

function DelLeadingSlash(const Directory:string):string;
begin
  if Length(Trim(Directory))=0
  then result:=''
  else
    if Directory[1]='\'
    then result:=Copy(Directory,2,Length(Directory)-1)
    else result:=Directory;
end;

function AddPer(const szoveg:string):string;
begin
  if Length(Trim(szoveg)) = 0 then
    Result := ''
  else
    if szoveg[Length(szoveg)] <> '/' then
      Result := szoveg + '/'
    else
      Result := szoveg;
end;

function AddHttp(const szoveg:string):string;
begin
  if AnsiUpperCase(Copy(szoveg,1,7))<>'HTTP://'
  then result:='http://'+szoveg
  else result:=szoveg;
end;

function UnEscapeString(const szoveg,escape:string):string;
begin
  result:=RS(szoveg,'\',escape+escape);
  result:=RS(result,'''',escape+'''');
  result:=RS(result,'"',escape+'"');
end;

function MyExtractWord(const n:Integer;const mibol:String;const elvalaszto:Char):String;
var cikl,valdb:Integer;
begin
  Result:='';
  cikl:=1;
  valdb:=0;
  While (cikl<=Length(mibol)) And (valdb<n-1) Do Begin
    If mibol[cikl]=elvalaszto
    Then valdb:=valdb+1;
    cikl:=cikl+1;
  End;
  If valdb=n-1
  Then
    While (cikl<=Length(mibol)) And (mibol[cikl]<>elvalaszto) Do Begin
      Result:=Result+mibol[cikl];
      cikl:=cikl+1;
    End;
end;

function IsStrEmpty(const s:String):Boolean;
begin
  result:=Length(s)<=0;
end;

function OEM2Ansi(const s:String):String;
begin
//  OEMToChar(s,result);
end;

function Ansi2OEM(const s:String):String;
begin
//  CharToOEM(s,result);
end;

function CharCount(const miben:string; const mit:Char):Integer;
var cikl:Integer;
begin
  Result:=0;
  for cikl:=1 to Length(miben) do
    if miben[cikl]=mit
    then Result:=Result+1;
end;

function Str2Int(const s:string):Integer;
begin
  try
    Result:=StrToInt(s);
  except
    Result:=0;
  end;
end;

function Winesit(const mit:string):string;
var cikl:Integer;
begin
  Result:='';
  for cikl:=1 to Length(mit) do
    case mit[cikl] of
      #160:Result:=Result+'';
      #130:Result:=Result+'';
      #161:Result:=Result+'';
      #162:Result:=Result+'';
      #148:Result:=Result+'';
      #147:Result:=Result+'';
      #163:Result:=Result+'';
      #129:Result:=Result+'';
      #150:Result:=Result+'';
      #143:Result:=Result+'';
      #144:Result:=Result+'';
      #149:Result:=Result+'';
      #153:Result:=Result+'';
      #167:Result:=Result+'';
      #151:Result:=Result+'';
      #154:Result:=Result+'';
      else Result:=Result+mit[cikl];
    end;
end;

function Dososit(const mit:string):string;
var cikl:Integer;
begin
  Result:='';
  for cikl:=1 to Length(mit) do
    case mit[cikl] of
      '':Result:=Result+#160;
      '':Result:=Result+#130;
      '':Result:=Result+#161;
      '':Result:=Result+#162;
      '':Result:=Result+#148;
      '':Result:=Result+#147;
      '':Result:=Result+#163;
      '':Result:=Result+#129;
      '':Result:=Result+#150;
      '':Result:=Result+#143;
      '':Result:=Result+#144;
      '':Result:=Result+#149;
      '':Result:=Result+#153;
      '':Result:=Result+#167;
      '':Result:=Result+#151;
      '':Result:=Result+#154;
      else Result:=Result+mit[cikl];
    end;
end;

function Ekezettelenit(const szoveg:string):string;
var cikl:Integer;
begin
  Result:='';
  for cikl:=1 to Length(szoveg) do
    case szoveg[cikl] of
      #160:Result:=Result+'a';
      #130:Result:=Result+'e';
      #161:Result:=Result+'i';
      #162:Result:=Result+'o';
      #148:Result:=Result+'o';
      #147:Result:=Result+'o';
      #163:Result:=Result+'u';
      #129:Result:=Result+'u';
      #150:Result:=Result+'u';
      #143:Result:=Result+'A';
      #144:Result:=Result+'E';

      #149:Result:=Result+'O';
      #153:Result:=Result+'O';
      #167:Result:=Result+'O';
      #151:Result:=Result+'U';
      #154:Result:=Result+'U';
      '':Result:=Result+'a';
      '':Result:=Result+'e';
      '':Result:=Result+'i';
      '':Result:=Result+'o';
      '':Result:=Result+'o';
      '':Result:=Result+'o';
      '':Result:=Result+'u';
      '':Result:=Result+'u';
      '':Result:=Result+'u';
      '':Result:=Result+'A';
      '':Result:=Result+'E';
      '':Result:=Result+'I';
      '':Result:=Result+'O';
      '':Result:=Result+'O';
      '':Result:=Result+'O';
      '':Result:=Result+'U';
      '':Result:=Result+'U';
      '':Result:=Result+'U';
      else Result:=Result+szoveg[cikl];
    end;
end;

function CutLastChar(const mibol:string):string;
begin
  result:=Copy(mibol,1,Length(mibol)-1);
end;

Function SzamotBetuvel(Szamm: Longint;Const Valuta: String): String;
Const
  Egyesek  : array[1..9] of String = ('egy','kett','hrom','ngy','t','hat','ht','nyolc','kilenc');
  Tizesek0 : array[1..9] of String = ('tz','hsz','harminc','negyven','tven','hatvan','hetven','nyolcvan','kilencven');
  Tizesek  : array[1..9] of String = ('tizen','huszon','harminc','negyven','tven','hatvan','hetven','nyolcvan','kilencven');
  Nagyok   : array[1..4] of String = ('','ezer','milli','millird');
Var
  S: String;
  I,Y,E,T,Sz: Longint;
  Szam: Longint;

Begin
  If Szamm<0 Then
    Szam:=Abs(Szamm)
  Else
    Szam:=Szamm;

  If Szam=0 Then
    Result:='nulla'
  Else Begin
    S:='';
    I:=0;
    If Szam>=1 Then Begin
      While Szam>=1 Do Begin
        Inc(I);
        Y:=(Szam mod 1000);                            // Az utols 3 szmjegy
        Szam:=Trunc(Szam/1000)+(Szam-Trunc(Szam));                // A tizedesek meghagysval
        If Y<>0 Then Begin                              // az utols 3 jegy levgsa
          E:=Trunc(Y mod 10);                         // egyes helyirtk
          Y:=Trunc(Y/10);
          T:=Trunc(Y mod 10);                         // tzes helyirtk
          Y:=Trunc(Y/10);
          Sz:=Trunc(Y mod 10);                        // szzas helyirtk

          If I>1 Then
            S:=Nagyok[i]+'-'+S
          Else
            S:=Nagyok[i]+S;                            // nagysgrend

          If E<>0 Then                                // Ha van egyesek hozzfzse
            S:=Egyesek[E]+S;

          If T<>0 Then                                // Ha van tizesek hozzfzse
            If E=0 Then                              // Ha nincs egyes akkor
              S:=Tizesek0[T]+S                   // 'tiz','husz',... hozzfzse
            Else
              S:=Tizesek[T]+S;                    // 'tizen',... hozzfzse

          If Sz<>0 Then                               // Ha van szzasok hozzfzse
            S:=Egyesek[Sz]+'szz'+S;

        End;
      End;
      Delete(S,Length(S)+1,1);
      S:=S+Valuta;
    End;

    If Szam>0 Then Begin                                      // Vannak mg fillrek is
      Y:=Round(Szam)*100;                     // Csak kt tizedes
      S:=S+' '+SzamotBetuvel(Y, Valuta)           // Fillrek hozzfzse
    End;
  End;
  If Szamm<0 Then
    Result:=' mnusz '+s
  Else
    Result:=s;
End;

Function SzamotBetuvel(Szamm: Double;Const Valuta: String): String;
Const
  Egyesek  : array[1..9] of String = ('egy','kett','hrom','ngy','t','hat','ht','nyolc','kilenc');
  Tizesek0 : array[1..9] of String = ('tz','hsz','harminc','negyven','tven','hatvan','hetven','nyolcvan','kilencven');
  Tizesek  : array[1..9] of String = ('tizen','huszon','harminc','negyven','tven','hatvan','hetven','nyolcvan','kilencven');
  Nagyok   : array[1..4] of String = ('','ezer','milli','millird');
Var
  S: String;
  I,Y,E,T,Sz: Longint;
  Szam: Longint;

Begin
  Szam:=Abs(Trunc(Szamm));
  If Szam=0 Then
    Result:='nulla'
  Else Begin
    S:='';
    I:=0;
    If Szam>=1 Then Begin
      While Szam>=1 Do Begin
        Inc(I);
        Y:=(Szam mod 1000);                            // Az utols 3 szmjegy
        Szam:=Szam div 1000;                // A tizedesek meghagysval
        If Y<>0 Then Begin                              // az utols 3 jegy levgsa
          E:=Y mod 10;                         // egyes helyirtk
          Y:=Y div 10;
          T:=Y mod 10;                         // tzes helyirtk
          Y:=Y div 10;
          Sz:=Y mod 10;                        // szzas helyirtk

          If I>1 Then
            S:=Nagyok[i]+'-'+S
          Else
            S:=Nagyok[i]+S;                            // nagysgrend

          If E<>0 Then                                // Ha van egyesek hozzfzse
            S:=Egyesek[E]+S;

          If T<>0 Then                                // Ha van tizesek hozzfzse
            If E=0 Then                              // Ha nincs egyes akkor
              S:=Tizesek0[T]+S                   // 'tiz','husz',... hozzfzse
            Else
              S:=Tizesek[T]+S;                    // 'tizen',... hozzfzse

          If Sz<>0 Then                               // Ha van szzasok hozzfzse
            S:=Egyesek[Sz]+'szz'+S;

        End;
      End;
      Delete(S,Length(S)+1,1);
    End;

    If Frac(Szamm)>0
    Then Begin                                      // Vannak mg fillrek is
      S:=S+' egsz '+SzamotBetuvel(Round(Frac(Szamm)*100), Valuta)           // Fillrek hozzfzse
    End
    else s:=s+valuta;
  End;
  If Szamm<0 Then
    Result:=' mnusz '+s
  Else
    Result:=s;
End;

Function SzamotBetuvel2(Szamm: Longint): String;
Const
  Egyesek  : array[1..9] of String = ('egy','kett','hrom','ngy','t','hat','ht','nyolc','kilenc');
  Tizesek0 : array[1..9] of String = ('tz','hsz','harminc','negyven','tven','hatvan','hetven','nyolcvan','kilencven');
  Tizesek  : array[1..9] of String = ('tizen','huszon','harminc','negyven','tven','hatvan','hetven','nyolcvan','kilencven');
  Nagyok   : array[1..4] of String = ('','ezer','milli','millird');
Var
  S,valuta: String;
  I,Y,E,T,Sz: Longint;
  Szam: Longint;

Begin
  Szam:=Szamm;
  Valuta:='';
  If Szam=0 Then
    Result:='nulla'
  Else Begin
    S:='';
    I:=0;
    If Szam>=1 Then Begin
      While Szam>=1 Do Begin
        Inc(I);
        Y:=(Szam mod 1000);                            // Az utols 3 szmjegy
        Szam:=Trunc(Szam/1000)+(Szam-Trunc(Szam));                // A tizedesek meghagysval
        If Y<>0 Then Begin                              // az utols 3 jegy levgsa
          E:=Trunc(Y mod 10);                         // egyes helyirtk
          Y:=Trunc(Y/10);
          T:=Trunc(Y mod 10);                         // tzes helyirtk
          Y:=Trunc(Y/10);
          Sz:=Trunc(Y mod 10);                        // szzas helyirtk

          If I>1 Then
            S:=Nagyok[i]+'-'+S
          Else
            S:=Nagyok[i]+S;                            // nagysgrend

          If E<>0 Then                                // Ha van egyesek hozzfzse
            S:=Egyesek[E]+S;

          If T<>0 Then                                // Ha van tizesek hozzfzse
            If E=0 Then                              // Ha nincs egyes akkor
              S:=Tizesek0[T]+S                   // 'tiz','husz',... hozzfzse
            Else
              S:=Tizesek[T]+S;                    // 'tizen',... hozzfzse

          If Sz<>0 Then                               // Ha van szzasok hozzfzse
            S:=Egyesek[Sz]+'szz'+S;

        End;
      End;
      S:=S+Valuta;
    End;
//    Delete(S,Length(S)-1,1);
    If Szam>0 Then Begin                                      // Vannak mg fillrek is
      Y:=Round(Szam)*100;                     // Csak kt tizedes
      S:=S+' '+SzamotBetuvel2(Y);           // Fillrek hozzfzse
    End;
  End;
  Result:=s;
End;

Function SzamotBetuvel3(Szamm: Double;Const Valuta: String): String;
Const
  Egyesek  : array[1..9] of String = ('egy','kett','hrom','ngy','t','hat','ht','nyolc','kilenc');
  Tizesek0 : array[1..9] of String = ('tz','hsz','harminc','negyven','tven','hatvan','hetven','nyolcvan','kilencven');
  Tizesek  : array[1..9] of String = ('tizen','huszon','harminc','negyven','tven','hatvan','hetven','nyolcvan','kilencven');
  Nagyok   : array[1..4] of String = ('','ezer','milli','millird');
Var
  S: String;
  I,Y,E,T,Sz: Longint;
  Szam: Double;

Begin
  If Szamm<0 Then
    Szam:=Abs(Round(Szamm))
  Else
    Szam:=Szamm;

  If Szam=0 Then
    S:='nulla'
  Else Begin
    S:='';
    I:=0;
    If Szam>=1 Then Begin
      While Szam>=1 Do Begin
        Inc(I);
        Y:=MyMod(Szam,1000);                            // Az utols 3 szmjegy
        Szam:=Trunc(Szam/1000)+(Szam-Trunc(Szam));                // A tizedesek meghagysval
        If Y<>0 Then Begin                              // az utols 3 jegy levgsa
          E:=Trunc(Y mod 10);                         // egyes helyirtk
          Y:=Trunc(Y/10);
          T:=Trunc(Y mod 10);                         // tzes helyirtk
          Y:=Trunc(Y/10);
          Sz:=Trunc(Y mod 10);                        // szzas helyirtk

          If I>1 Then
            S:=Nagyok[i]+'-'+S
          Else
            S:=Nagyok[i]+S;                            // nagysgrend

          If E<>0 Then                                // Ha van egyesek hozzfzse
            S:=Egyesek[E]+S;

          If T<>0 Then                                // Ha van tizesek hozzfzse
            If E=0 Then                              // Ha nincs egyes akkor
              S:=Tizesek0[T]+S                   // 'tiz','husz',... hozzfzse
            Else
              S:=Tizesek[T]+S;                    // 'tizen',... hozzfzse

          If Sz<>0 Then                               // Ha van szzasok hozzfzse
            S:=Egyesek[Sz]+'szz'+S;

        End;
      End;
      If Copy(S,Length(S),Length(S)+1) = '-' Then
        Delete(S,Length(S),1);
      S:=S+Valuta;
    End;

    If Szam>0 Then Begin                                      // Vannak mg fillrek is
      Y:=Round(Szam)*100;                     // Csak kt tizedes
      S:=S+' '+SzamotBetuvel(Y, Valuta)           // Fillrek hozzfzse
    End;
  End;
  If Szamm<0 Then
    Result:=' mnusz '+s
  Else
    Result:=s;
End;

Function SzamotBetuvel_4(Const Szam: Double): String;
Const
  Ed : array[1..4] of String = ('tized','szzad','ezred','tizezred');
Var
  Tort: Double;
  Egesz: String;
  TortLong: Longint;
  x: Integer;
Begin
  Egesz:=SzamotBetuvel2(Trunc(Szam));
  Tort:=Szam-Trunc(Szam);
  X:=Length(FLoATToStrF(Tort,ffNumber,18,2))-2;
  TortLong:=Round(Tort*IntPower(10,X));
  If TortLong <> 0 Then
    Result:=Egesz+' forint '+SzamotBetuvel2(TortLong)+' fillr'        {Ed[X]}
  Else
    Result:=Egesz+' forint';
End;

Function MyMod(Const X,Y: Double): Longint;
Begin
  Result:=Trunc(X-Trunc((X / Y))*Y);
End;

function AddSeparated(const mihez,s,sep:string):string;
begin
  if mihez<>''
  then Result:=mihez+sep+s
  else Result:=s;
end;

function LeftCopy(const mibol:string;const mennyit:integer):string;
begin
  result:=Copy(mibol,1,mennyit);
end;

function DateToLongStr(const mibol:TDate):string;
const honap:array[1..12] of string=('janur','februr','mrcius','prilis','mjus',
  'jnius','jlius','augusztus','szeptember','oktber','november','december');
var ev,ho,nap:word;
begin
  DecodeDate(mibol,ev,ho,nap);
  result:=IntToStr(ev)+'. v '+honap[ho]+' h '+IntToStr(nap)+'.';
end;

function TimeToFileName(const mibol:TDateTime):string;
var o,p,mp,ms:word;
begin
  DecodeTime(mibol,o,p,mp,ms);
  result:=IntToStrZero(o,2)+IntToStrZero(p,2)+IntToStrZero(mp,2)+IntToStrZero(ms,3);
end;

function DateToFileName(const mibol:TDateTime):string;
var e,h,n:word;
begin
  DecodeDate(mibol,e,h,n);
  result:=IntToStrZero(e,4)+IntToStrZero(h,2)+IntToStrZero(n,2);
end;

function DateToExcel(const mibol:TDateTime):string;
var e,h,n:word;
begin
  DecodeDate(mibol,e,h,n);
  result:=IntToStrZero(e,4)+'-'+IntToStrZero(h,2)+'-'+IntToStrZero(n,2);
end;

procedure CimSzetszed(const cim:string;var irszam,varos,utca:string);
var p:integer;
begin
  p:=Pos(',',cim);
  varos:=Copy(cim,1,p-1);
  utca:=Trim(Copy(cim,p+1,Length(cim)));
  p:=Pos(' ',varos);
  irszam:=Copy(varos,1,p);
  varos:=Trim(Copy(varos,p+1,Length(varos)));
end;

function FloatToStrEzres(const mibol:extended):string;
begin
  if mibol>9999
  then result:=FormatFloat(',############.##',mibol)
  else result:=FloatToStr(mibol);
end;

function CreateAddress(const irszam,varos,utca:string):string;
begin
  result:=irszam+' '+varos+', '+utca;
end;

end.
