unit fSQLBackupSettings;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Spin, EditBtn
  ,ZlawMySQLBackup
  ;

type

  { TfrmSQLBackupSettings }

  TfrmSQLBackupSettings = class(TForm)
    cbCreateDatabase: TCheckBox;
    cbDeleteDatabase: TCheckBox;
    cbDeleteTable: TCheckBox;
    cbDisableKeysAtInsert: TCheckBox;
    cbDropObjects: TCheckBox;
    cbDumpData: TCheckBox;
    cbFlushLogsBeforeDump: TCheckBox;
    cbFunctions: TCheckBox;
    cbInsertWithFields: TCheckBox;
    cbLockAroundInserts: TCheckBox;
    cbProcedures: TCheckBox;
    cbReplaceBadCharacters: TCheckBox;
    cbRestoreToNewDatabase: TCheckBox;
    cbSetKeyChecksOn: TCheckBox;
    cbTables: TCheckBox;
    cbTriggers: TCheckBox;
    cbUseDatabase: TCheckBox;
    cbViews: TCheckBox;
    comboAusgabe: TComboBox;
    comboDaten: TComboBox;
    DirectoryEdit1: TDirectoryEdit;
    FileNameEdit1: TFileNameEdit;
    GroupBox1: TGroupBox;
    lblDirectory: TLabel;
    lblAusgabe: TLabel;
    lblDatabase: TLabel;
    lblDateiname: TLabel;
    lblDaten: TLabel;
    lblMaxInsert: TLabel;
    lblTable: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    SpinEdit1: TSpinEdit;
    procedure FormCreate(Sender: TObject);
  private

  public
    function GetOptions(pOptions: TZlawMySQLBackupOptions): TZlawMySQLBackupOptions;
    function GetObjects(pObjects: TZlawMySQLBackupObjects): TZlawMySQLBackupObjects;
  end;

var
  frmSQLBackupSettings: TfrmSQLBackupSettings;

implementation

{$R *.lfm}

{ TfrmSQLBackupSettings }

procedure TfrmSQLBackupSettings.FormCreate(Sender: TObject);
begin
  Panel1.Color:=clDefault;
  Panel2.Color:=clDefault;
  Panel3.Color:=clDefault;
  GroupBox1.Color:=clDefault;
end;

function TfrmSQLBackupSettings.GetOptions(pOptions: TZlawMySQLBackupOptions
  ): TZlawMySQLBackupOptions;
begin
  //Database
  if cbDeleteDatabase.Checked then
    result:= pOptions + [lmbDropDatabase]
  else
    result:= pOptions - [lmbDropDatabase];

  if cbCreateDatabase.Checked then
    result:= pOptions + [lmbCreateDatabase]
  else
    result:= pOptions - [lmbCreateDatabase];

  if cbUseDatabase.Checked then
    result:= pOptions + [lmbUseDatabase]
  else
    result:= pOptions - [lmbUseDatabase];

  //Table
  if cbDeleteTable.Checked then
    result:= pOptions + [lmbCreateDatabase]
  else
    result:= pOptions - [lmbCreateDatabase];

  if cbDumpData.Checked then
    result:= pOptions + [lmbDumpData]
  else
    result:= pOptions - [lmbDumpData];

  if cbLockAroundInserts.Checked then
    result:= pOptions + [lmbLockAroundInserts]
  else
    result:= pOptions - [lmbLockAroundInserts];

  if cbInsertWithFields.Checked then
    result:= pOptions + [lmbInsertWithFields]
  else
    result:= pOptions - [lmbInsertWithFields];

  if cbFlushLogsBeforeDump.Checked then
    result:= pOptions + [lmbFlushLogsBeforeDump]
  else
    result:= pOptions - [lmbFlushLogsBeforeDump];

  if cbSetKeyChecksOn.Checked then
    result:= pOptions + [lmbSetKeyChecksOn]
  else
    result:= pOptions - [lmbSetKeyChecksOn];

  if cbRestoreToNewDatabase.Checked then
    result:= pOptions + [lmbRestoreToNewDatabase]
  else
    result:= pOptions - [lmbRestoreToNewDatabase];

  if cbDropObjects.Checked then
    result:= pOptions + [lmbDropObjects]
  else
    result:= pOptions - [lmbDropObjects];

  if cbDisableKeysAtInsert.Checked then
    result:= pOptions + [lmbDisableKeysAtInsert]
  else
    result:= pOptions - [lmbDisableKeysAtInsert];

  if cbReplaceBadCharacters.Checked then
    result:= pOptions + [lmbReplaceBadCharacters]
  else
    result:= pOptions - [lmbReplaceBadCharacters];
end;

function TfrmSQLBackupSettings.GetObjects(pObjects: TZlawMySQLBackupObjects
  ): TZlawMySQLBackupObjects;
begin
  if cbTables.Checked then
    result:= pObjects + [lmboTables]
  else
    result:= pObjects - [lmboTables];

  if cbViews.Checked then
    result:= pObjects + [lmboViews]
  else
    result:= pObjects - [lmboViews];

  if cbProcedures.Checked then
    result:= pObjects + [lmboProcedures]
  else
    result:= pObjects - [lmboProcedures];

  if cbFunctions.Checked then
    result:= pObjects + [lmboFunctions]
  else
    result:= pObjects - [lmboFunctions];

  if cbTriggers.Checked then
    result:= pObjects + [lmboTriggers]
  else
    result:= pObjects - [lmboTriggers];
end;
end.

